
#include "comb/combination-altminchange.h"

#include "bits/revbin.h"

#include "bits/printbin.h"
#include "jjassert.h"

#include "fxttypes.h"
#include "fxtio.h"
#include "fxtiomanip.h"

#include "demo/nextarg.h"


//% Generating (n choose k) combinations (alternative) minimal-change order.


void
foo(ulong n, ulong k)
{
    cout << " n = " << n << "  k = " << k << ":" << endl;
    jjassert( n>0 );
    jjassert( k>0 );
    jjassert( n>=k );

    ulong ct = 0;
    combination_altminchange comb(n, k);

    comb.first();
//    comb.last();
    do
    {
        ulong bits = revbin( ~comb.bits_, n);  // reversed and negated
        cout << "   ";
        for (long k=n-1; k>=0; --k)  cout << ((bits>>k)&1 ? '1' : '.');

        cout << "   [ " << comb << " ]  ";

        cout << "  swap: (" << comb.sw1_ << ", " << comb.sw2_ << ") ";

        cout << "  #" << setw(3) << ct;

        ++ct;
        cout << endl;
    }
    while ( comb.next() );
//    while ( comb.prev() );

    cout << endl;
    cout << endl;
}
// -------------------------

int
main(int argc, char **argv)
{
    ulong n = 7;
    NXARG(n,"combinations (n choose k): n>0");
    ulong k = 4;
    NXARG(k,"0<k<=n");

    foo(n, k);

    return 0;
}
// -------------------------
